$.uuid = 0;
var APP_VERSION = '1.0.1';
var isAndroid = (/android/gi).test(navigator.appVersion);
var Storage = (function() {
    var uzStorage = function() {
        var ls = window.localStorage;
        if (isAndroid) {
            ls = os.localStorage();
        }
        return ls;
    };
    var _storage = {};
    _storage.setStorage = function(key, value) {
        if (arguments.length === 2) {
            var v = value;
            if (typeof v == 'object') {
                v = JSON.stringify(v);
                v = 'obj-' + v;
            } else {
                v = 'str-' + v;
            }
            var ls = uzStorage();
            if (ls) {
                ls.setItem(key, v);
            }
        }
    };
    _storage.getStorage = function(key) {
        var ls = uzStorage();
        if (ls) {
            var v = ls.getItem(key);
            if (!v) {
                return;
            }
            if (v.indexOf('obj-') === 0) {
                v = v.slice(4);
                return JSON.parse(v);
            } else if (v.indexOf('str-') === 0) {
                return v.slice(4);
            }
        }
    };
    _storage.rmStorage = function(key) {
        var ls = uzStorage();
        if (ls && key) {
            ls.removeItem(key);
        }
    };
    _storage.clearStorage = function() {
        var ls = uzStorage();
        if (ls) {
            ls.clear();
        }
    };
    return _storage;
})();

function LOG(args) {
    if (typeof args === 'object') {
        console.log(JSON.stringify(args));
    } else {
        console.log(args);
    }
}

/******************************通用操作******************************/
var headerHeight = 0;
var footerHeight = 0;

function fixStatusBar() {
    var _eHeader = $api.dom('header');
    if (isAndroid) return _eHeader.offsetHeight;
    headerHeight = $api.fixStatusBar(_eHeader);
    return headerHeight;
}

function fixTabBar() {
    var footer = $api.dom('footer');
    footerHeight = $api.fixTabBar(footer);
    return footerHeight;
}

function closeWin(delay) {
    if (delay) {
        setTimeout(function() {
            api.closeWin();
        }, delay);
    } else {
        api.closeWin();
    }
}

/******************************打开Win 或者 Frame******************************/
function openCustomWinByObject(obj) {
    var winOptions = {
        name: 'page_win',
        url: '',
        bounces: false,
        delay: 0,
        useWKWebView: true,
        slidBackEnabled: true,
        vScrollBarEnabled: false,
        reload: true,
        overScrollMode: 'scrolls',
        bgColor: '#ffffff',
        progress: {
            type: 'default',
            title: '稍等',
            text: '努力加载中…',
            color: '#ffff00'
        },
        pageParam: {},
        animation: {
            type: 'push',
            subType: 'from_right'
        },
        headers: {
            token: USER.getUserToken()
        }
    };

    // 检查是否需要登录
    var userToken = false;
    if ($(obj).data('need-login')) {
        userToken = checkLogin();
        if (!userToken) {
            return false;
        }

    }

    // data-win="window.name"
    if ($(obj).data('win')) winOptions.name = $(obj).data('win');
    // data-external="window.name" url is external page （外部页面）
    if ($(obj).data('external')) winOptions.name = $(obj).data('external');

    // url = href or data-href
    if ($(obj).attr('href')) winOptions.url = $(obj).attr('href');
    if ($(obj).data('href')) winOptions.url = $(obj).data('href');

    // 如果存在 external（外部页面参数）
    if ($(obj).data('external')) {
        winOptions.bounces = true;
        winOptions.url = APP_SERVER_HOST + winOptions.url;
        if (userToken) winOptions.url += '&token=' + userToken;
    }

    if ($(obj).data('animation-subtype')) winOptions.animation.subType = $(obj).data('animation-subtype');

    if (api.systemType !== 'ios') winOptions.delay = 300;

    // 桥接页面
    // data-bridge="window.title"
    // data-href="url"
    // or href="url"
    if ($(obj).data('bridge')) {
        winOptions.pageParam = {
            mainFooterHeight: footerHeight,
            title: $(obj).data('bridge'),
            url: winOptions.url
        };
        winOptions.url = 'bridge_win.html';
    }

    if (winOptions.url.indexOf('html') === 0 && window.location.href.indexOf('http') === 0) {
        var pos = window.location.href.indexOf('html/');
        if (pos > 0) winOptions.url = window.location.href.substr(0, pos) + winOptions.url;
    }
    // LOG(winOptions);
    api.openWin(winOptions);
}
$(function() {
    $(document.body).on('tap', 'a, .link-btn', function(e) {
        e.preventDefault();
        openCustomWinByObject(this);
    });
});

/**
 * 打开自定义Win
 * @param params
 */
function customerOpenWin(params) {
    var winOptions = {
        name: 'page_win',
        url: params.url,
        bounces: !!params.bounces,
        delay: 0,
        useWKWebView: true,
        slidBackEnabled: true,
        vScrollBarEnabled: false,
        reload: true,
        overScrollMode: 'scrolls',
        bgColor: '#ffffff',
        progress: {
            type: 'default',
            title: '稍等',
            text: '努力加载中…',
            color: '#ffff00'
        },
        animation: {
            type: 'push',
            subType: 'from_right'
        },
        headers: {
            token: USER.getUserToken()
        }
    };

    if (api.systemType !== 'ios') winOptions.delay = 300;
    if (params.name) winOptions.name = params.name;
    // 本地URL地址
    if (winOptions.url.indexOf('html') === 0 && window.location.href.indexOf('http') === 0) {
        var pos = window.location.href.indexOf('html/');
        if (pos > 0) {
            winOptions.url = window.location.href.substr(0, pos) + winOptions.url;
        }
    }
    // 页面动画
    if (params.animation_subType) winOptions.animation.subType = params.animation_subType;
    // 是否桥接页面
    if (params.bridge) {
        winOptions.pageParam = {
            title: params.title,
            url: params.url
        };
        winOptions.url = 'bridge_win.html';
    }

    // LOG(winOptions);
    api.openWin(winOptions);
}

/**
 * 打开自定义Frame
 * @param params
 */
function customerOpenFrame(params) {
    api.openFrame($.extend({
        name: 'main_win',
        url: '',
        bounces: false,
        rect: {
            w: 'auto'
        },
        animation: {
            type: 'fade'
        },
        progress: {
            type: 'default',
            title: '稍等',
            text: '努力加载中…',
            color: '#ffff00'
        },
        headers: {
            token: USER.getUserToken()
        }
    }, params));
}

/**
 * 用户信息操作
 */
var USER = {
    getUserProfile: function() {
        return Storage.getStorage('UserProfile');
    },
    setUserProfile: function(data) {
        Storage.setStorage('UserProfile', data);
    },
    getUserToken: function() {
        return Storage.getStorage('UserToken');
    },
    setUserToken: function(data) {
        Storage.setStorage('UserToken', data);
    },
    userLogout: function() {
        Storage.rmStorage('UserToken');
        Storage.rmStorage('UserProfile');
    },
    notFirstLaunch: function(yes) {
        if (yes) {
            Storage.setStorage('notFirstLaunch', true);
        } else {
            return Storage.getStorage('notFirstLaunch');
        }
    }
};

function customerEvent(params) {
    LOG(params);
}

function checkLogin() {
    var _token = USER.getUserToken();
    if (_token) {
        return _token;
    } else {
        customerOpenWin({
            title: '登录',
            name: 'login_win',
            bridge: true,
            url: 'login.html'
        });
        return false;
    }
}

$.ajaxSettings.dataType = 'json';
$.ajaxSettings.cache = false;
$.ajaxSettings.timeout = 10 * 1000;
$.ajaxSettings.beforeSend = function(xhr, request) {
    xhr.setRequestHeader('token', USER.getUserToken());
};

function valid_mobile_format(mobile) {
    return /^0?1[3|4|5|6|7|8|9][0-9]\d{8}$/.test(mobile);
}

apiready = function() {
    api.parseTapmode();
    api.setStatusBarStyle({
        style: 'light'
    });

    event = document.createEvent("HTMLEvents");
    event.initEvent("apiready", true, true);
    event.eventName = "apiready";
    document.dispatchEvent(event);

}
