var weixin = null;
function loginSuccess(token) {
    USER.setUserToken(token);
    // var push = api.require('push');
    // push.bind({
    //     userName: userToken,
    //     userId: userToken
    // }, function(ret, err) { });
    api.sendEvent({
        name: 'loginSuccess',
        extra: {
            token: token
        }
    });
    api.toast({
        msg: '登录成功！',
        duration: 2000,
        location: 'bottom'
    });
    closeWin(1000);
}

var objSendCodeWaiting, statusSendCodeWaiting, intervalSendCodeWaiting, timeoutSendCodeWaiting;

function sendCode(obj) {
    if (statusSendCodeWaiting) return false;
    var _mobile = $('#mobile').val();
    if (!valid_mobile_format(_mobile)) {
        api.alert({
            title: '错误提示',
            msg: '手机号格式错误！'
        });
        return false;
    }

    objSendCodeWaiting = $(obj);
    statusSendCodeWaiting = true;
    timeoutSendCodeWaiting = 60;

    intervalSendCodeWaiting = setInterval(function () {
        timeoutSendCodeWaiting--;
        $(objSendCodeWaiting).text(timeoutSendCodeWaiting + '秒后' + $(objSendCodeWaiting).data('waiting'));
        if (timeoutSendCodeWaiting <= 0) {
            clearInterval(intervalSendCodeWaiting);
            statusSendCodeWaiting = false;
            $(objSendCodeWaiting).text($(objSendCodeWaiting).data('title'));
        }
    }, 1000);

    $.ajax({
        url: API_AUTH_SEND_CODE,
        data: {
            mobile: _mobile
        },
        dataType: 'json',
        type: 'post',
        success: function (response) {
            if (response.success) {
                api.toast({
                    msg: '短信验证码发送成功，请注意查收！',
                    duration: 3000,
                    location: 'middle'
                });
            } else {
                api.alert({
                    title: '错误提示',
                    msg: response.message,
                }, function (ret, err) {
                });
            }
        },
        error: function (response) {
            api.alert({
                title: '错误提示',
                msg: '短信验证码发送失败，请稍后再试！',
            }, function (ret, err) {
            });
        }
    });
}

function loginByMobile(obj) {
    var _mobile = $('#mobile').val();
    if (!valid_mobile_format(_mobile)) {
        api.alert({
            title: '错误提示',
            msg: '手机号格式错误！'
        });
        return false;
    }

    var _code = $('#code').val();
    if (!/^[0-9]{6}$/.test(_code)) {
        api.alert({
            title: '错误提示',
            msg: '验证码格式错误！'
        });
        return false;
    }

    api.showProgress({
        title: '登录中...',
        modal: true
    });

    $.ajax({
        url: API_AUTH_BY_MOBILE,
        data: {
            mobile: _mobile,
            code: _code
        },
        dataType: 'json',
        type: 'post',
        success: function (response) {
            api.hideProgress();
            if (response.success) {
                loginSuccess(response.data.token);
            } else {
                api.alert({
                    title: '错误提示',
                    msg: response.message,
                }, function (ret, err) {
                });
            }
        },
        error: function (response) {
            api.hideProgress();
            api.alert({
                title: '错误提示',
                msg: '登录出错，请稍后再试！',
            }, function (ret, err) {
            });
        }
    });
}

function loginByQQ() {
    var qq = api.require('qq');
    qq.login(function (ret, err) {
        api.alert({
            title: 'id和token',
            msg: ret.openId + ret.accessToken
        });

        $.ajax({
            url: API_AUTH_BY_QQ,
            data: {
                openId: ret.openId
            },
            dataType: 'json',
            type: 'post',
            cache: false,
            timeout: 5000,
            success: function (response) {
                if (response.success) {
                    loginSuccess(response.data.token);
                } else {
                    api.alert({
                        title: '错误提示',
                        msg: 'QQ登录出错，请稍后再试！',
                    }, function (ret, err) {
                    });
                }
            },
            error: function () {
                api.alert({
                    title: '错误提示',
                    msg: 'QQ登录出错，请稍后再试！',
                }, function (ret, err) {
                });
            }
        });
    });
}

// 登录授权（用于实现第三方登录）
function loginByWx() {
    weixin.auth({
        // apiKey: 'wxa02fb832806930cc',
        // scope: 'snsapi_userinfo'
    }, function (ret, err) {
        alert(JSON.stringify(ret));
        if (ret.status) {
            getWxToken(ret['code']);
        } else {
            alert(JSON.stringify(err));
            var errMsg = '微信登录出错，请稍后再试！';
            switch (err['code']) {
                case -1:
                    errMsg = '未知错误';
                    break;
                case 0:
                    errMsg = '成功，用户同意';
                    break;
                case 1:
                    errMsg = '用户取消';
                    break;
                case 2:
                    errMsg = '用户拒绝授权';
                    break;
                case 3:
                    errMsg = '当前设备未安装微信客户端';
                    break;
                default:
                    errMsg = '微信登录出错，请稍后再试！';
            }
            api.alert({
                title: '错误提示[1]',
                msg: errMsg
            });
        }
    });
}

// 获取授权 accessToken（需要登录授权成功）
function getWxToken(code) {
    weixin.getToken({
        // apiKey: '',
        // apiSecret: '',
        code: code
    }, function (ret, err) {
        if (ret.status) {
            // {
            //   status: true,      //布尔型；true||false
            //   accessToken: '',   //字符串类型；接口调用凭证，传给 getUserInfo 接口 获取用户信息；有效期2小时
            //   dynamicToken: '',  //字符串类型；当 accessToken 过期时把该值传给 refreshToken 接口刷新 accessToken 的有效期。dynamicToken 的有效期为30天
            //   expires: 7200,     //数字类型；accessToken 有效期，单位（秒）
            //   openId: ''         //字符串类型；授权用户唯一标识
            // }
            getWxUserInfo(ret['accessToken'], ret['openId']);
        } else {
            // {
            //   code: 0     //数字类型；
            //   //错误码：
            //   //-1（未知错误），
            //   //0 （成功）
            //   //1 (apiKey值为空或非法)
            //   //2 (apiSecret值为空或非法)
            //   //3 (code值为空或非法)
            //   //4 (网络超时)
            // }
            api.alert({
                title: '错误提示[2]',
                msg: '微信登录出错，请稍后再试！'
            });
        }
    });
}

// 获取用户信息（需要获取 accessToken 成功）
function getWxUserInfo(accessToken, openId) {
    weixin.getUserInfo({
        accessToken: accessToken,
        openId: openId
    }, function (ret, err) {
        if (ret.status) {
            // {
            //   status: true,      //布尔型；true||false
            //   openid: '',        //字符串类型；普通用户的标识，对当前开发者帐号唯一
            //   nickname: '',      //字符串类型；普通用户昵称
            //   sex: 1,            //数字类型；普通用户性别，1为男性，2为女性
            //   headimgurl: '',    //字符串类型；用户头像，最后一个数值代表正方形头像大小（有0、46、64、96、132数值可选，0代表640*640正方形头像），用户没有头像时该项为空
            //   privilege: [],     //数组类型；用户特权信息，如微信沃卡用户为（chinaunicom）
            //   unionid: ''        //字符串类型；用户统一标识。针对一个微信开放平台帐号下的应用，同一用户的unionid是唯一的。
            // }
            loginWxSubmit(ret);
        } else {
            // {
            //   code: 0     //数字类型；
            //   //错误码：
            //   //-1（未知错误），
            //   //0 （成功）,
            //   //1 （accessToken 过期）,
            //   //2  (openId非法),
            //   //3  (openId值为空),
            //   //4     (accessToken值为空),
            //   //5     (accessToken非法)
            //   //6     (网络超时)
            // }
            api.alert({
                title: '错误提示[3]',
                msg: '微信登录出错，请稍后再试！'
            });
        }
    });
}

function loginWxSubmit(params) {
    $.ajax({
        url: API_AUTH_BY_WX,
        data: params,
        dataType: 'json',
        type: 'post',
        cache: false,
        timeout: 5 * 1000,
        success: function (response) {
            if (response.success) {
                loginSuccess(response.data.token);
            } else {
                api.alert({
                    title: '错误提示[5]',
                    msg: '微信登录出错，请稍后再试！'
                });
            }
        },
        error: function () {
            api.alert({
                title: '错误提示[4]',
                msg: '微信登录出错，请稍后再试！'
            });
        }
    });
}

$(document).on('apiready', function () {
    weixin = api.require('wx');
    weixin.isInstalled(function (ret, err) {
        if (ret.installed) {
            $('#J_thirdLoginMethodBox').show();
            $('#J_btnLoginByWx').show();
            // LOG("当前设备已安装微信客户端");
        } else {
            $('#J_btnLoginByWx').hide();
            $('#J_thirdLoginMethodBox').hide();
            // alert('当前设备未安装微信客户端');
        }
    });
});
